﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{


    protected void Page_Load(object sender, EventArgs e)
    {
        if(!IsPostBack)
            Session["ds"] = MakeTable();
        (WebDataGrid1.EditorProviders[0] as DropDownProvider).EditorControl.DataSource = MakeTable();
        (WebDataGrid1.EditorProviders[0] as DropDownProvider).EditorControl.SelectionChanged += new Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventHandler(EditorControl_SelectionChanged);
        WebDataGrid1.InitializeRow += new Infragistics.Web.UI.GridControls.InitializeRowEventHandler(WebDataGrid1_InitializeRow);
        WebDataGrid1.DataSource = Session["ds"];
        WebDataGrid1.DataBind();
    }



    public int selectedRow = 0;
    void EditorControl_SelectionChanged(object sender, Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs e)
    {

        DataTable dt = Session["ds"] as DataTable;
       
        selectedRow = (int)e.NewSelection;
        GridRecord r = WebDataGrid1.Behaviors.Selection.SelectedRows[0];
      
        dt.Rows[r.Index]["Item"] =(int) e.NewSelection;
        WebDataGrid wdg = r.Items[2].FindControl("WebDataGrid2") as WebDataGrid;

        wdg.DataSource = MakeTable((int)e.NewSelection, (int)e.NewSelection + 3);
        wdg.DataBind();
        Session["ds"] = dt;

        WebDataGrid1.RequestFullAsyncRender();

             
    }

    void WebDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        int currDropDownValue = (int)e.Row.Items[1].Value;
        WebDataGrid wdg= e.Row.Items[2].FindControl("WebDataGrid2") as WebDataGrid;
        wdg.DataSource = MakeTable(currDropDownValue, currDropDownValue+3);
        wdg.DataBind();
    }

    private DataTable MakeTable(int start=0, int end=20)
     {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        if (end > 20)
            end = 20;
       
        for (int i = start; i <= end; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }

   


}
